import { LitElement } from 'lit';
/**
 * A github corner.
 */
export declare class GitHubCorners extends LitElement {
    static styles: import("lit").CSSResult;
    /**
     * target="_blank" for link
     */
    blank: boolean;
    /**
     * Font color
     */
    color: string;
    /**
     * Fill color for github corners
     */
    fill: string;
    /**
     * Your GitHub Repo Name, generate url start with <https://github.com>.
     */
    repo: string;
    /**
     * You also can custom it to override the url generated by repo.
     */
    url: string;
    /**
     * Hover title
     */
    label: string;
    /**
     * Reverse color and fill
     */
    reverse: boolean;
    /**
     * Position of github corners, 'left' or 'right'
     */
    position: string;
    getPositionStyles(position: string): string;
    render(): import("lit").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'github-corners': GitHubCorners;
    }
}
