var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { LitElement, css, html } from 'lit';
import { customElement, property } from 'lit/decorators.js';
/**
 * A github corner.
 */
export var GitHubCorners = /** @class */ (function (_super) {
    __extends(GitHubCorners, _super);
    function GitHubCorners() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * target="_blank" for link
         */
        _this.blank = false;
        /**
         * Font color
         */
        _this.color = '#fff';
        /**
         * Fill color for github corners
         */
        _this.fill = '#151513';
        /**
         * Your GitHub Repo Name, generate url start with <https://github.com>.
         */
        _this.repo = 'YunYouJun/wc-github-corners';
        /**
         * You also can custom it to override the url generated by repo.
         */
        _this.url = '';
        /**
         * Hover title
         */
        _this.label = 'View source on GitHub';
        /**
         * Reverse color and fill
         */
        _this.reverse = false;
        /**
         * Position of github corners, 'left' or 'right'
         */
        _this.position = 'right';
        return _this;
    }
    GitHubCorners.prototype.getPositionStyles = function (position) {
        if (position === 'left')
            return 'left:0;transform: scale(-1, 1);';
        else
            return 'right:0;';
    };
    GitHubCorners.prototype.render = function () {
        var styles = "position: absolute;top: 0;border: 0;".concat(this.getPositionStyles(this.position));
        return html(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      <a href=\"", "\" class=\"github-corner\" aria-label=\"", "\"\n        target=\"", "\" style=\"", "\">\n        <svg width=\"80\" height=\"80\" viewBox=\"0 0 250 250\" fill=\"", "\"\n          color=\"", "\" aria-hidden=\"true\">\n          <path d=\"M0,0 L115,115 L130,115 L142,142 L250,250 L250,0 Z\"></path>\n          <path\n            d=\"M128.3,109.0 C113.8,99.7 119.0,89.6 119.0,89.6 C122.0,82.7 120.5,78.6 120.5,78.6 C119.2,72.0 123.4,76.3 123.4,76.3 C127.3,80.9 125.5,87.3 125.5,87.3 C122.9,97.6 130.6,101.9 134.4,103.2\"\n            fill=\"currentColor\" style=\"transform-origin: 130px 106px\" class=\"octo-arm\"></path>\n          <path\n            d=\"M115.0,115.0 C114.9,115.1 118.7,116.5 119.8,115.4 L133.7,101.6 C136.9,99.2 139.9,98.4 142.2,98.6 C133.8,88.0 127.5,74.4 143.8,58.0 C148.5,53.4 154.0,51.2 159.7,51.0 C160.3,49.4 163.2,43.6 171.4,40.1 C171.4,40.1 176.1,42.5 178.8,56.2 C183.1,58.6 187.2,61.8 190.9,65.4 C194.5,69.0 197.7,73.2 200.1,77.6 C213.8,80.2 216.3,84.9 216.3,84.9 C212.7,93.1 206.9,96.0 205.4,96.6 C205.1,102.4 203.0,107.8 198.3,112.5 C181.9,128.9 168.3,122.5 157.7,114.1 C157.9,116.9 156.7,120.9 152.7,124.9 L141.0,136.5 C139.8,137.7 141.6,141.9 141.8,141.8 Z\"\n            fill=\"currentColor\" class=\"octo-body\"></path>\n        </svg>\n      </a>\n    "], ["\n      <a href=\"", "\" class=\"github-corner\" aria-label=\"", "\"\n        target=\"", "\" style=\"", "\">\n        <svg width=\"80\" height=\"80\" viewBox=\"0 0 250 250\" fill=\"", "\"\n          color=\"", "\" aria-hidden=\"true\">\n          <path d=\"M0,0 L115,115 L130,115 L142,142 L250,250 L250,0 Z\"></path>\n          <path\n            d=\"M128.3,109.0 C113.8,99.7 119.0,89.6 119.0,89.6 C122.0,82.7 120.5,78.6 120.5,78.6 C119.2,72.0 123.4,76.3 123.4,76.3 C127.3,80.9 125.5,87.3 125.5,87.3 C122.9,97.6 130.6,101.9 134.4,103.2\"\n            fill=\"currentColor\" style=\"transform-origin: 130px 106px\" class=\"octo-arm\"></path>\n          <path\n            d=\"M115.0,115.0 C114.9,115.1 118.7,116.5 119.8,115.4 L133.7,101.6 C136.9,99.2 139.9,98.4 142.2,98.6 C133.8,88.0 127.5,74.4 143.8,58.0 C148.5,53.4 154.0,51.2 159.7,51.0 C160.3,49.4 163.2,43.6 171.4,40.1 C171.4,40.1 176.1,42.5 178.8,56.2 C183.1,58.6 187.2,61.8 190.9,65.4 C194.5,69.0 197.7,73.2 200.1,77.6 C213.8,80.2 216.3,84.9 216.3,84.9 C212.7,93.1 206.9,96.0 205.4,96.6 C205.1,102.4 203.0,107.8 198.3,112.5 C181.9,128.9 168.3,122.5 157.7,114.1 C157.9,116.9 156.7,120.9 152.7,124.9 L141.0,136.5 C139.8,137.7 141.6,141.9 141.8,141.8 Z\"\n            fill=\"currentColor\" class=\"octo-body\"></path>\n        </svg>\n      </a>\n    "])), this.url || "https://github.com/".concat(this.repo), this.label, this.blank ? '_blank' : null, styles, this.reverse ? this.color : this.fill, this.reverse ? this.fill : this.color);
    };
    GitHubCorners.styles = css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n    .github-corner:hover .octo-arm {\n      animation: octocat-wave 560ms ease-in-out;\n    }\n\n    @keyframes octocat-wave {\n      0%,\n      100% {\n        transform: rotate(0);\n      }\n      20%,\n      60% {\n        transform: rotate(-25deg);\n      }\n      40%,\n      80% {\n        transform: rotate(10deg);\n      }\n    }\n\n    @media (max-width: 500px) {\n      .github-corner:hover .octo-arm {\n        animation: none;\n      }\n      .github-corner .octo-arm {\n        animation: octocat-wave 560ms ease-in-out;\n      }\n    }\n  "], ["\n    .github-corner:hover .octo-arm {\n      animation: octocat-wave 560ms ease-in-out;\n    }\n\n    @keyframes octocat-wave {\n      0%,\n      100% {\n        transform: rotate(0);\n      }\n      20%,\n      60% {\n        transform: rotate(-25deg);\n      }\n      40%,\n      80% {\n        transform: rotate(10deg);\n      }\n    }\n\n    @media (max-width: 500px) {\n      .github-corner:hover .octo-arm {\n        animation: none;\n      }\n      .github-corner .octo-arm {\n        animation: octocat-wave 560ms ease-in-out;\n      }\n    }\n  "
        /**
         * target="_blank" for link
         */
    ])));
    __decorate([
        property({ type: Boolean })
    ], GitHubCorners.prototype, "blank", void 0);
    __decorate([
        property({ type: String })
    ], GitHubCorners.prototype, "color", void 0);
    __decorate([
        property({ type: String })
    ], GitHubCorners.prototype, "fill", void 0);
    __decorate([
        property({ type: String })
    ], GitHubCorners.prototype, "repo", void 0);
    __decorate([
        property({ type: String })
    ], GitHubCorners.prototype, "url", void 0);
    __decorate([
        property({ type: String })
    ], GitHubCorners.prototype, "label", void 0);
    __decorate([
        property({ type: Boolean })
    ], GitHubCorners.prototype, "reverse", void 0);
    __decorate([
        property({ type: String })
    ], GitHubCorners.prototype, "position", void 0);
    GitHubCorners = __decorate([
        customElement('github-corners')
    ], GitHubCorners);
    return GitHubCorners;
}(LitElement));
var templateObject_1, templateObject_2;
